import { LitElement } from 'lit';
export type PopoverContainerPlacement = 'top' | 'top-start' | 'top-end' | 'bottom' | 'bottom-start' | 'bottom-end' | 'right' | 'right-start' | 'right-end' | 'left' | 'left-start' | 'left-end';
/**
 * @element uui-popover-container
 */
export declare class UUIPopoverContainerElement extends LitElement {
    #private;
    /**
     * Set the distance between popover container element and target element.
     * @type {number}
     * @attr margin
     * @default 0
     */
    margin: number;
    /**
     * Read-only attribute to check if the popover is open
     * @type {boolean}
     * @readonly
     * @attr open
     * @default false
     */
    get open(): boolean;
    /**
     * Define the placement of the popover container.
     * @attr placement
     * @default 'bottom-start'
     */
    get placement(): PopoverContainerPlacement;
    set placement(newValue: PopoverContainerPlacement);
    _placement: PopoverContainerPlacement;
    _open: boolean;
    _actualPlacement: PopoverContainerPlacement;
    connectedCallback(): void;
    disconnectedCallback(): void;
    render(): import("lit-html").TemplateResult<1>;
    static styles: import("lit").CSSResult[];
}
declare global {
    interface HTMLElementTagNameMap {
        'uui-popover-container': UUIPopoverContainerElement;
    }
}
